import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'icon_plugin_platform_interface.dart';

/// An implementation of [IconPluginPlatform] that uses method channels.
class MethodChannelIconPlugin extends IconPluginPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('icon_plugin');

  @override
  Future<String> setIcon({required String icon}) async {
    await methodChannel.invokeMethod<String>('setIcon', [icon]);
    return icon;
  }
}
