import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'icon_plugin_method_channel.dart';

abstract class IconPluginPlatform extends PlatformInterface {
  /// Constructs a IconPluginPlatform.
  IconPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static IconPluginPlatform _instance = MethodChannelIconPlugin();

  /// The default instance of [IconPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelIconPlugin].
  static IconPluginPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [IconPluginPlatform] when
  /// they register themselves.
  static set instance(IconPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String> setIcon({required String icon}) {
    return Future(() => icon);
  }
}
