import 'package:flutter_test/flutter_test.dart';
import 'package:icon_plugin/icon_plugin.dart';
import 'package:icon_plugin/icon_plugin_platform_interface.dart';
import 'package:icon_plugin/icon_plugin_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockIconPluginPlatform
    with MockPlatformInterfaceMixin
    implements IconPluginPlatform {
  @override
  Future<String> setIcon({required String icon}) => Future(() => icon);
}

void main() {
  final IconPluginPlatform initialPlatform = IconPluginPlatform.instance;

  test('$MethodChannelIconPlugin is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelIconPlugin>());
  });

  test('setIcon', () async {
    IconPlugin iconPlugin = IconPlugin();
    MockIconPluginPlatform fakePlatform = MockIconPluginPlatform();
    IconPluginPlatform.instance = fakePlatform;

    expect(iconPlugin.setIcon(icon: 'favicon.png'), 'favicon.png');
  });
}
